/*! \file OptionsChar.h 
 *  \brief: header file for optionschar object
 */

#ifndef _OPTIONSCHAR_H_
#define _OPTIONSCHAR_H_

/*Headers:{{{1*/
#include "../../include/include.h"
#include "../../shared/Exceptions/exceptions.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

#include "./OptionsObject.h"
/*}}}*/

class OptionsChar: public OptionsObject {

	public:

		char* values;

		/*OptionsChar constructors, destructors {{{1*/
		OptionsChar();
		~OptionsChar();
		/*}}}*/
		/*Object virtual functions definitions:{{{1*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		int   Id();
		int   MyRank();
		void  Marshall(char** pmarshalled_dataset);
		int   MarshallSize();
		void  Demarshall(char** pmarshalled_dataset);
		int   Enum();
		Object* copy();
		/*}}}*/

		/*virtual functions: */
		char* Name();
		int   NumEl();
		int   NDims();
		int*  Size();
//		Object* Get();
//  get by single index, multiple index, simple find, recursive find

};
#endif  /* _OPTIONSCHAR_H */

